###############################################################################
# YaBB.pl                                                                     #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.2                                        #
# Released:       December 2001; Updated March 12, 2003                       #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################

$sublistplver = "1 Gold - SP 1.3";

%director=(
'printwhoisonline',"Subs.pl&printwhoisonline",
'bdquotes',"BoardquotesSP1.pl&Boardquotes1",
'bdquotes2',"BoardquotesSP1.pl&Boardquotes2",
'recent1',"Subs.pl&LastTopics",
'ext_admin',"ExtendedProfiles.pl&ext_admin",
'ext_edit',"ExtendedProfiles.pl&ext_admin_edit",
'ext_edit2',"ExtendedProfiles.pl&ext_admin_edit2",
'ext_create',"ExtendedProfiles.pl&ext_admin_create",
'ext_reorder',"ExtendedProfiles.pl&ext_admin_reorder",
'chatset1',"ChatSettings.pl&ChatSettings1",
'chatset2',"ChatSettings.pl&ChatSettings2",
'chatnow',"Chat.pl&yabbchat",
'chatssi',"ChatSSI.pl&RecentChat_SSI",
'chatsmilieput',"Chat.pl&ChatSmiliePut",
'chatsmilieindex',"Chat.pl&ChatSmilieIndex",
'printusersonchat',"ChatSSI.pl&printusersonchat",
'printguestsonchat',"ChatSSI.pl&printguestsonchat",
'includecal',"NewcalIndex.pl&IncludeCal",
'newcalendar',"Newcalendar.pl&CalMain",
'newcalset',"NewcalSettings.pl&CalSettings",
'newcalset2',"NewcalSettings.pl&CalSettings2",
'newcalmini',"NewcalPost.pl&MiniCalSSI",
'newcalmini2',"NewcalPost.pl&MiniCalSSI2",	
'sendevent',"SendEvent.pl&SendEvent",
'sendevent2',"SendEvent.pl&SendEvent2",
'lockpoll',"Poll.pl&LockPoll",
'showvoters',"Poll.pl&votedetails",
'vote',"Poll.pl&DoVote",
'undovote',"Poll.pl&UndoVote",
'login',"LogInOut.pl&Login",
'login2',"LogInOut.pl&Login2",
'logout',"LogInOut.pl&Logout",
'lock',"LockThread.pl&LockThread",
'display',"Display.pl&Display",
'detailedversion',"Admin.pl&ver_detail",
'deletemultimembers',"Admin.pl&DeleteMultiMembers",
'deletemultimessages',"InstantMessage.pl&Del_Some_IM",
'modify',"ModifyMessage.pl&ModifyMessage",
'modify2',"ModifyMessage.pl&ModifyMessage2",
'modtemp',"AdminEdit.pl&ModifyTemplate",
'modtemp2',"AdminEdit.pl&ModifyTemplate2",
'modagreement',"AdminEdit.pl&ModifyAgreement",
'modagreement2',"AdminEdit.pl&ModifyAgreement2",
'modsettings',"AdminEdit.pl&ModifySettings",
'modsettings2',"AdminEdit.pl&ModifySettings2",
'modmemgr',"AdminEdit.pl&EditMemberGroups",
'modmemgr2',"AdminEdit.pl&EditMemberGroups2",
'movethread',"MoveThread.pl&MoveThread",
'movethread2',"MoveThread.pl&MoveThread2",
'modifycatorder',"ManageCats.pl&ReorderCats",
'modifycat',"ManageCats.pl&ModifyCat",
'modifyboard',"ManageBoards.pl&ModifyBoard",
'markasread',"MessageIndex.pl&MarkRead",
'multiadmin',"RemoveThread.pl&Multi",
'markallasread',"BoardIndex.pl&MarkAllRead",
'managecats',"ManageCats.pl&ManageCats",
'mailing',"Admin.pl&MailingList",
'membershiprecount',"Admin.pl&AdminMembershipRecount",
'mlall',"Memberlist.pl&MLAll",
'mlalldes',"Memberlist.pl&MLAll",
'mlalfa',"Memberlist.pl&MLAll",
'mlemail',"Memberlist.pl&MLAll",
'mlgrp',"Memberlist.pl&MLAll",
'mlpost',"Memberlist.pl&MLAll",
'mlipnum',"Memberlist.pl&MLAll",
'mlipsearch',"Memberlist.pl&MLByIP",
'mlletter',"Memberlist.pl&MLByLetter",
'mltop',"Memberlist.pl&MLTop",
'mlbuddy',"YamBuddylist.pl&MLBuddy",
'mlbuddy2',"Memberlist.pl&MLBuddy2",
'mlbuddy3',"YamBuddylist.pl&MLBuddy3",
'mlbuddy4',"YamBuddylist.pl&MLBuddy4",
'manageboards',"ManageBoards.pl&ManageBoards",
'ml',"Admin.pl&ml",
'managebuddies',"BuddyList.pl&ManageBuddies",
'managebuddies2',"BuddyList.pl&ManageBuddies2",
'markims',"InstantMessage.pl&MarkAll",
'mmall',"MemberMap.pl&MMall",
'mmall2',"MemberMap.pl&MMall2",
'mmedit',"MemberMap.pl&MMedit",
'mmedit2',"MemberMap.pl&MMedit2",
'post',"Post.pl&Post",
'post2',"Post.pl&Post2",
'print',"Printpage.pl&Print",
'profile',"Profile.pl&ModifyProfile",
'profile2',"Profile.pl&ModifyProfile2",
'register',"Register.pl&Register",
'register2',"Register.pl&Register2",
'reminder',"LogInOut.pl&Reminder",
'reminder2',"LogInOut.pl&Reminder2",
'removethread',"RemoveThread.pl&RemoveThread",
'recent',"Recent.pl&RecentPosts",
'removeoldthreads',"RemoveOldThreads.pl&RemoveOldThreads",
'reorderboards',"ManageBoards.pl&ReorderBoards",
'reorderboards2',"ManageBoards.pl&ReorderBoards2",
'rebuildmemlist',"Admin.pl&RebuildMemList",
'rebuildmemnumb',"Admin.pl&RebuildMemNumb",
'rebuildmemnumb2',"Admin.pl&RebuildMemNumb2",
'im',"InstantMessage.pl&IMIndex",
'imoutbox',"InstantMessage.pl&IMIndex",
'imstorage',"InstantMessage.pl&IMIndex",
'imtostore',"InstantMessage.pl&IMToStore",
'imremove',"InstantMessage.pl&IMRemove",
'imsend',"InstantMessage.pl&IMPost",
'imsend2',"InstantMessage.pl&IMPost2",
'imshow',"InstantMessage.pl&IMShow",
'imgroups',"InstantMessage.pl&IMGroups",
'imprint',"Printpage.pl&Print_IM",
'imcb',"InstantMessage.pl&CallBack",
'icqpager',"ICQPager.pl&IcqPager",
'ipban',"Admin.pl&ipban",
'ipban2',"Admin.pl&ipban2",
'createcat',"ManageCats.pl&CreateCat",
'clean_log',"Admin.pl&clean_log",
'notify',"Notify.pl&Notify",
'notify2',"Notify.pl&Notify2",
'notify3',"Notify.pl&Notify3",
'notify4',"Notify.pl&Notify4",
'sendtopic',"SendTopic.pl&SendTopic",
'sendtopic2',"SendTopic.pl&SendTopic2",
'setcensor',"AdminEdit.pl&SetCensor",
'setcensor2',"AdminEdit.pl&SetCensor2",
'search',"Search.pl&plushSearch1",
'search2',"Search.pl&plushSearch2",
'setmembmap',"AdminEdit.pl&SetMembermap",
'setmembmap2',"AdminEdit.pl&SetMembermap2",
'setcountry2',"AdminEdit.pl&SetCountry2",
'setstate2',"AdminEdit.pl&SetState2",
'setreserve',"AdminEdit.pl&SetReserve",
'setreserve2',"AdminEdit.pl&SetReserve2",
'showclicks',"Admin.pl&ShowClickLog",
'shownotify',"Notify.pl&ShowNotifications",
'stats',"Admin.pl&FullStats",
'sticky',"Subs.pl&Sticky",
'sort',"BuddyList.pl&SortBuddies",
'addsmilies',"Smilies.pl&AddSmilies",
'smilies',"Smilies.pl&SmiliePanel",
'smilieput',"Smilies.pl&SmiliePut",
'smilieindex',"Smilies.pl&SmilieIndex",
'smiliemove',"Smilies.pl&SmilieMove",
'viewprofile',"Profile.pl&ViewProfile",
'viewmembers',"Admin.pl&ViewMembers",
'addboard',"ManageBoards.pl&CreateBoard",
'admin',"Admin.pl&Admin",
'boardrecount',"Admin.pl&AdminBoardRecount",
'editnews',"AdminEdit.pl&EditNews",
'editnews2',"AdminEdit.pl&EditNews2",
'messageindex',"MessageIndex.pl&MessageIndex",  
'usersrecentposts',"Profile.pl&usersrecentposts");


1;